<?php


function config_export_import_drush_command()
{
    $items = [];
    $items['cex-file'] = [
        'description' => 'Export Config Single file',
        'aliases' => ['cexf'],
        'arguments' => [
            'path' => 'Path location',
            'config_name' => 'Export new only.',
        ],
    ];
    $items['cim-file'] = [
            'description' => 'Import Config Single file',
            'aliases' => ['cimf'],
            'arguments' => [
                'config_name' => 'Import new only.'
            ],
    ];

    return $items;
}
function drush_config_export_import_cim_file($config_name  = NULL)
{
    $config_settings = \Drupal::config("config_export_import.settings") ;
     $service = \Drupal::service('config_export_import.manager');
     if($config_settings->get('root')){
       $root = $config_settings->get('root') ;
     } else{
            drush_print('Please fill Config root location in  /admin/config/development/configuration/config-manual-setting ');
            return NULL ;
     }
     if ($config_name == NULL) {
        drush_print('Please config name you want to import (for example : core.entity_form_display.node.article.default ) : ');
        $config_name = drush_prompt(dt('Config name'));
         $config_name = trim($config_name);
     }
     if($service->isExistDatabase($config_name)){
        drush_print('Config exist already in our database');
        if (!drush_confirm('Do you want continue to import ?'))  {
            return NULL ;
        }
     }
     if($service->isExistLocal($config_name)){
      $file_path = $service->isExistLocal($config_name);    
      $service->checkDependencyModule($current_path,'drush');
      $dependencies = $service->getAllDependencyByFolder( $file_path,false,'drush');
      
      drush_print('Dependencies list : ');
      foreach ($dependencies as $key => $dep) {
            $file = str_replace( DRUPAL_ROOT.$root,'',$dep['file'] );
            if(!$service->isExistDatabase($dep['config_name'])){  
                 drush_print( $file.' ( new ) ' );
            }else{
                 drush_print( $file.' ( exist ) ');      
            }
      }
      if (drush_confirm('Do you want to import with dependency ?')) { $with_dep = true ; }else{  $with_dep = false ; }
      if($with_dep){
            if (drush_confirm('Do you want to import only new dependency config ?'))  { $new_only = true ; }else{  $new_only = false ; }
      }
      if($with_dep && !empty($dependencies)){
            foreach ($dependencies as $key => $dep) {
                        if(!$service->isExistDatabase($dep['config_name'])){  
                                $service->importConfig($dep['file'],'drush');
                                drush_print('New config dependency '.$dep['config_name'] .' important successfully ');
                        }else{
                            if(!$new_only){
                                  $service->importConfig($dep['file'],'drush');
                                drush_print('Updated config dependency '.$dep['config_name'] .' important successfully ');
                            }
                        }
            }
      }
      if(!$service->isExistDatabase($config_name)){  
             $service->importConfig($file_path,'drush');
             drush_print('New config '.$config_name.' important successfully ');
      }else{
             $service->importConfig($file_path,'drush');
             drush_print('Updated config '.$config_name .' important successfully ');
      }
     }else{
           drush_print('Sorry, config '.$config_name.' not exist  in our folders ');
           return NULL;
     }
 
   
}
function drush_config_export_import_cex_file($path = NULL ,$config_name  = NULL)
{
     $config_settings = \Drupal::config("config_export_import.settings") ;
     $service = \Drupal::service('config_export_import.manager');
     if($config_settings->get('root')){
       $root = $config_settings->get('root') ;
     } else{
            drush_print('Please fill Config root location in  /admin/config/development/configuration/config-manual-setting ');
            return NULL ;
     }
     
    if ($path == NULL) {
        $folder_list = $service->getDirectoryList(DRUPAL_ROOT.$root);     
        drush_print('Existing Folder config list :');
        drush_print('/');
        if(!empty($folder_list)){
                foreach( $folder_list as $folder){
                    drush_print($folder);
                }
        }    
        drush_print('Where do you want to add your config ? ');
        $path = drush_prompt(dt('Path folder'));
        $path = trim($path);
    }
    if ($config_name == NULL) {
        drush_print('Please config name you want to export (for example : core.entity_form_display.node.article.default ) : ');
        $config_name = drush_prompt(dt('Config name'));
         $config_name = trim($config_name);
    }
    if($service->isExistLocal($config_name)){
      $current_path = $service->isExistLocal($config_name);
      $current_path = str_replace( DRUPAL_ROOT.$root,'',$current_path );
      drush_print('Config exist already in '.$current_path );
      if (!drush_confirm('Do you want continue to export '.$config_name.' in '.$path.'?')) {
          return NULL ;
      }
    }
    $dependencies = $service->getAllDependencyByDatabase($config_name);
    drush_print('Dependencies : '.implode(' - ',$dependencies));
    if (drush_confirm('Do you want to export with dependency ?')) { $with_dep = true ; }else{  $with_dep = false ; }
    if($with_dep){
      if (drush_confirm('Do you want to export only new dependency config in folder config ?'))  { $new_only = true ; }else{  $new_only = false ; }
    }
    if($with_dep && !empty($dependencies )){
            foreach ($dependencies as $key => $dep) {
                        if(!$service->isExistLocal($dep)){
                                $service->exportConfig($key, $path);
                                drush_print('New config '.$key .' export successfully ');
                        }else{
                            if(!$new_only){
                                $service->exportConfig($key, $path);
                                drush_print('Updated config '.$key .' export successfully ');
                            }
                        }
            }
    }
    $service->exportConfig($config_name,$path);
    if(!$service->isExistLocal($config_name)){
        drush_print('New config '.$config_name .' export successfully ');
    }else{
        drush_print('Updated config '.$config_name .' export successfully ');
    }
}




